
ASP.NET Boilerplate
===================

What is ABP?
------------

ASP.NET Boilerplate is a starting point for new modern web applications using best practices and most popular tools. It's aimed to be a __SOLID__ model, a general-purpose __application framework__ and a project __template__.

### Framework

ASP.NET Boilerplate is an application framework built on latest __ASP.NET MVC__ & __Web API__ technologies. It makes easy to use dependency injection, logging, validation, exception handling, localization and so on. It makes these not only itself but also using most popular framework and libraries.

### Architecture

ASP.NET Boilerplate implements __NLayer architecture__ (Domain, Application, Infrastructure and Presentation Layers) and __Domain Driven Design__ (Entities, Repositories, Domain/Application Services, DTO's...). Also implements and provides a good infrastructure to implement __best practices__ such as __Dependency Injection__.

### Template

ASP.NET Boilerplate easily creates startup template for your project. It includes most used framework and libraries by default. Also allows you to choice __Single-Page__ (SPA: Angularjs or Durandaljs) or __Multi-Page__ (MVC) architecture, EntityFramework or NHibernate as ORM.

Features
--------

### Framework

These are some key features of the framework itself:

- Modular and NLayered architecture
- Multi-tenancy
- Dependency Injection
- Domain Driven Design
- Unit of work implementation
- Flexible Localization system
- Automatic data filters
- Audit logging
- Setting management
- Menu management
- Authorization
- Exception handling
- Validation
- Logging
- Event bus for domain events
- Auto-creating Web API layer for Application Services
- Auto-creating Javascript proxy layer to use Web API layer
- Javascript helper methods for ajax, notifications, message boxes, making UI busy...
- Easily working with embedded resources
- Useful extension and helper methods

### Module-Zero

Module-Zero is the module that implements abstract concepts of the framework, also adds some useful stuff for enterprise web applications:

- Multi-tenancy
- Role management
- User management
- Session management
- Setting management
- Audit logging

See https://github.com/aspnetboilerplate/module-zero for more

Links
-----

* Web site: http://www.aspnetboilerplate.com
* Forum: http://forum.aspnetboilerplate.com
